Index: libgomp/iter.c
===================================================================
--- libgomp/iter.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ libgomp/iter.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -218,7 +218,7 @@
 	}
     }
 
-  start = ws->next;
+  start = __atomic_load_n (&ws->next, MEMMODEL_RELAXED);
   while (1)
     {
       long left = end - start;
@@ -301,7 +301,7 @@
   long start, end, nend, incr;
   unsigned long chunk_size;
 
-  start = ws->next;
+  start = __atomic_load_n (&ws->next, MEMMODEL_RELAXED);
   end = ws->end;
   incr = ws->incr;
   chunk_size = ws->chunk_size;
Index: libgomp/iter_ull.c
===================================================================
--- libgomp/iter_ull.c	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ libgomp/iter_ull.c	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -219,7 +219,7 @@
 	}
     }
 
-  start = ws->next_ull;
+  start = __atomic_load_n (&ws->next_ull, MEMMODEL_RELAXED);
   while (1)
     {
       gomp_ull left = end - start;
@@ -305,7 +305,7 @@
   gomp_ull start, end, nend, incr;
   gomp_ull chunk_size;
 
-  start = ws->next_ull;
+  start = __atomic_load_n (&ws->next_ull, MEMMODEL_RELAXED);
   end = ws->end_ull;
   incr = ws->incr_ull;
   chunk_size = ws->chunk_size_ull;
Index: libgomp/ChangeLog
===================================================================
--- libgomp/ChangeLog	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ libgomp/ChangeLog	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -1,3 +1,13 @@
+2015-08-24  Joost VandeVondele  <vondele@gnu.gcc.org>
+
+	PR libgomp/66761
+	PR libgomp/67303
+	* iter.c (gomp_iter_dynamic_next): Employ an atomic load.
+	(gomp_iter_guided_next): Idem.
+	* iter_ull.c (gomp_iter_ull_dynamic_next): Idem.
+	(gomp_iter_ull_guided_next): Idem.
+	* config/linux/wait.h (do_spin): Idem.
+
 2015-07-16  Release Manager
 
 	* GCC 5.2.0 released.
Index: libgomp/config/linux/wait.h
===================================================================
--- libgomp/config/linux/wait.h	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ libgomp/config/linux/wait.h	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -49,7 +49,9 @@
 {
   unsigned long long i, count = gomp_spin_count_var;
 
-  if (__builtin_expect (gomp_managed_threads > gomp_available_cpus, 0))
+  if (__builtin_expect (__atomic_load_n (&gomp_managed_threads,
+                                         MEMMODEL_RELAXED)
+                        > gomp_available_cpus, 0))
     count = gomp_throttled_spin_count_var;
   for (i = 0; i < count; i++)
     if (__builtin_expect (__atomic_load_n (addr, MEMMODEL_RELAXED) != val, 0))
Index: libsanitizer/ChangeLog
===================================================================
--- libsanitizer/ChangeLog	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ libsanitizer/ChangeLog	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -1,3 +1,8 @@
+2015-09-09  Markus Trippelsdorf  <markus@trippelsdorf.de>
+
+	PR sanitizer/67258
+	* ubsan/ubsan_type_hash.cc: Cherry pick upstream r244101.
+
 2015-07-16  Release Manager
 
 	* GCC 5.2.0 released.
Index: libsanitizer/ubsan/ubsan_type_hash.cc
===================================================================
--- libsanitizer/ubsan/ubsan_type_hash.cc	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ libsanitizer/ubsan/ubsan_type_hash.cc	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -186,8 +186,8 @@
 
 struct VtablePrefix {
   /// The offset from the vptr to the start of the most-derived object.
-  /// This should never be greater than zero, and will usually be exactly
-  /// zero.
+  /// This will only be greater than zero in some virtual base class vtables
+  /// used during object con-/destruction, and will usually be exactly zero.
   sptr Offset;
   /// The type_info object describing the most-derived class type.
   std::type_info *TypeInfo;
@@ -197,7 +197,7 @@
   if (!*VptrPtr)
     return 0;
   VtablePrefix *Prefix = *VptrPtr - 1;
-  if (Prefix->Offset > 0 || !Prefix->TypeInfo)
+  if (!Prefix->TypeInfo)
     // This can't possibly be a valid vtable.
     return 0;
   return Prefix;
Index: libstdc++-v3/python/libstdcxx/v6/printers.py
===================================================================
--- libstdc++-v3/python/libstdcxx/v6/printers.py	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ libstdc++-v3/python/libstdcxx/v6/printers.py	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -980,6 +980,57 @@
     def display_hint (self):
         return 'string'
 
+class StdExpPathPrinter:
+    "Print a std::experimental::filesystem::path"
+
+    def __init__ (self, typename, val):
+        self.val = val
+        start = self.val['_M_cmpts']['_M_impl']['_M_start']
+        finish = self.val['_M_cmpts']['_M_impl']['_M_finish']
+        self.num_cmpts = int (finish - start)
+
+    def _path_type(self):
+        t = str(self.val['_M_type'])
+        if t[-9:] == '_Root_dir':
+            return "root-directory"
+        if t[-10:] == '_Root_name':
+            return "root-name"
+        return None
+
+    def to_string (self):
+        path = "%s" % self.val ['_M_pathname']
+        if self.num_cmpts == 0:
+            t = self._path_type()
+            if t:
+                path = '%s [%s]' % (path, t)
+        return "filesystem::path %s" % path
+
+    class _iterator(Iterator):
+        def __init__(self, cmpts):
+            self.item = cmpts['_M_impl']['_M_start']
+            self.finish = cmpts['_M_impl']['_M_finish']
+            self.count = 0
+
+        def __iter__(self):
+            return self
+
+        def __next__(self):
+            if self.item == self.finish:
+                raise StopIteration
+            item = self.item.dereference()
+            count = self.count
+            self.count = self.count + 1
+            self.item = self.item + 1
+            path = item['_M_pathname']
+            t = StdExpPathPrinter(item.type.name, item)._path_type()
+            if not t:
+                t = count
+            return ('[%s]' % t, path)
+
+    def children(self):
+        return self._iterator(self.val['_M_cmpts'])
+
+
 # A "regular expression" printer which conforms to the
 # "SubPrettyPrinter" protocol from gdb.printing.
 class RxPrinter(object):
@@ -1365,6 +1416,11 @@
                                   'optional', StdExpOptionalPrinter)
     libstdcxx_printer.add_version('std::experimental::fundamentals_v1::',
                                   'basic_string_view', StdExpStringViewPrinter)
+    # Filesystem TS components
+    libstdcxx_printer.add_version('std::experimental::filesystem::v1::',
+                                  'path', StdExpPathPrinter)
+    libstdcxx_printer.add_version('std::experimental::filesystem::v1::__cxx11::',
+                                  'path', StdExpPathPrinter)
 
     # Extensions.
     libstdcxx_printer.add_version('__gnu_cxx::', 'slist', StdSlistPrinter)
Index: libstdc++-v3/python/Makefile.am
===================================================================
--- libstdc++-v3/python/Makefile.am	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ libstdc++-v3/python/Makefile.am	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -49,7 +49,7 @@
 ## fragile, but there does not seem to be a better option, because
 ## libtool hides the real names from us.
 	@here=`pwd`; cd $(DESTDIR)$(toolexeclibdir); \
-	  for file in libstdc++*; do \
+	  for file in libstdc++.*; do \
 	    case $$file in \
 	      *-gdb.py) ;; \
 	      *.la) ;; \
Index: libstdc++-v3/scripts/testsuite_flags.in
===================================================================
--- libstdc++-v3/scripts/testsuite_flags.in	(.../tags/gcc_5_2_0_release)	(wersja 227896)
+++ libstdc++-v3/scripts/testsuite_flags.in	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -77,7 +77,8 @@
       echo ${PCHFLAGS}
       ;;
     --cxxldflags)
-      SECTIONLDFLAGS="@SECTION_LDFLAGS@ @LIBICONV@"
+      SECTIONLDFLAGS="@SECTION_LDFLAGS@ @LIBICONV@
+                      -L${BUILD_DIR}/src/filesystem/.libs"
       echo ${SECTIONLDFLAGS}
       ;;
     *)
Index: libstdc++-v3/src/filesystem/path.cc
===================================================================
--- libstdc++-v3/src/filesystem/path.cc	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ libstdc++-v3/src/filesystem/path.cc	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,471 @@
+// Class filesystem::path -*- C++ -*-
+
+// Copyright (C) 2014-2015 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// Under Section 7 of GPL version 3, you are granted additional
+// permissions described in the GCC Runtime Library Exception, version
+// 3.1, as published by the Free Software Foundation.
+
+// You should have received a copy of the GNU General Public License and
+// a copy of the GCC Runtime Library Exception along with this program;
+// see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
+// <http://www.gnu.org/licenses/>.
+
+#include <experimental/filesystem>
+
+using std::experimental::filesystem::path;
+
+std::experimental::filesystem::filesystem_error::~filesystem_error() = default;
+
+constexpr path::value_type path::preferred_separator;
+
+path&
+path::remove_filename()
+{
+  if (_M_type == _Type::_Multi)
+    {
+      if (!_M_cmpts.empty())
+	{
+	  auto cmpt = std::prev(_M_cmpts.end());
+	  _M_pathname.erase(cmpt->_M_pos);
+	  _M_cmpts.erase(cmpt);
+	  _M_trim();
+	}
+    }
+  else
+    clear();
+  return *this;
+}
+
+path&
+path::replace_filename(const path& replacement)
+{
+  remove_filename();
+  operator/=(replacement);
+  return *this;
+}
+
+path&
+path::replace_extension(const path& replacement)
+{
+  auto ext = _M_find_extension();
+  if (ext.first && ext.second != string_type::npos)
+    {
+      if (ext.first == &_M_pathname)
+	_M_pathname.erase(ext.second);
+      else
+	{
+	  const auto& back = _M_cmpts.back();
+	  if (ext.first != &back._M_pathname)
+	    _GLIBCXX_THROW_OR_ABORT(
+		std::logic_error("path::replace_extension failed"));
+	  _M_pathname.erase(back._M_pos + ext.second);
+	}
+    }
+  if (!replacement.empty() && replacement.native()[0] != '.')
+    _M_pathname += '.';
+  _M_pathname += replacement.native();
+  _M_split_cmpts();
+  return *this;
+}
+
+namespace
+{
+  template<typename Iter1, typename Iter2>
+    int do_compare(Iter1 begin1, Iter1 end1, Iter2 begin2, Iter2 end2)
+    {
+      int cmpt = 1;
+      while (begin1 != end1 && begin2 != end2)
+	{
+	  if (begin1->native() < begin2->native())
+	    return -cmpt;
+	  if (begin1->native() > begin2->native())
+	    return +cmpt;
+	  ++begin1;
+	  ++begin2;
+	  ++cmpt;
+	}
+      if (begin1 == end1)
+	{
+	  if (begin2 == end2)
+	    return 0;
+	  return -cmpt;
+	}
+      return +cmpt;
+    }
+}
+
+int
+path::compare(const path& p) const noexcept
+{
+  struct CmptRef
+  {
+    const path* ptr;
+    const string_type& native() const noexcept { return ptr->native(); }
+  };
+
+  if (_M_type == _Type::_Multi && p._M_type == _Type::_Multi)
+    return do_compare(_M_cmpts.begin(), _M_cmpts.end(),
+		      p._M_cmpts.begin(), p._M_cmpts.end());
+  else if (_M_type == _Type::_Multi)
+    {
+      CmptRef c[1] = { { &p } };
+      return do_compare(_M_cmpts.begin(), _M_cmpts.end(), c, c+1);
+    }
+  else if (p._M_type == _Type::_Multi)
+    {
+      CmptRef c[1] = { { this } };
+      return do_compare(c, c+1, p._M_cmpts.begin(), p._M_cmpts.end());
+    }
+  else
+    return _M_pathname.compare(p._M_pathname);
+}
+
+path
+path::root_name() const
+{
+  path __ret;
+  if (_M_type == _Type::_Root_name)
+    __ret = *this;
+  else if (_M_cmpts.size() && _M_cmpts.begin()->_M_type == _Type::_Root_name)
+    __ret = *_M_cmpts.begin();
+  return __ret;
+}
+
+path
+path::root_directory() const
+{
+  path __ret;
+  if (_M_type == _Type::_Root_dir)
+    __ret = *this;
+  else if (!_M_cmpts.empty())
+    {
+      auto __it = _M_cmpts.begin();
+      if (__it->_M_type == _Type::_Root_name)
+        ++__it;
+      if (__it != _M_cmpts.end() && __it->_M_type == _Type::_Root_dir)
+        __ret = *__it;
+    }
+  return __ret;
+}
+
+
+path
+path::root_path() const
+{
+  path __ret;
+  if (_M_type == _Type::_Root_name || _M_type == _Type::_Root_dir)
+    __ret = *this;
+  else if (!_M_cmpts.empty())
+    {
+      auto __it = _M_cmpts.begin();
+      if (__it->_M_type == _Type::_Root_name)
+        {
+          __ret = *__it++;
+          if (__it != _M_cmpts.end() && __it->_M_type == _Type::_Root_dir)
+            {
+              __ret._M_pathname += preferred_separator;
+              __ret._M_split_cmpts();
+            }
+        }
+      else if (__it->_M_type == _Type::_Root_dir)
+        __ret = *__it;
+    }
+  return __ret;
+}
+
+path
+path::relative_path() const
+{
+  path __ret;
+  if (_M_type == _Type::_Filename)
+    __ret = *this;
+  else if (!_M_cmpts.empty())
+    {
+      auto __it = _M_cmpts.begin();
+      if (__it->_M_type == _Type::_Root_name)
+        ++__it;
+      if (__it != _M_cmpts.end() && __it->_M_type == _Type::_Root_dir)
+        ++__it;
+      if (__it != _M_cmpts.end())
+        __ret.assign(_M_pathname.substr(__it->_M_pos));
+    }
+  return __ret;
+}
+
+path
+path::parent_path() const
+{
+  path __ret;
+  if (_M_cmpts.size() < 2)
+    return __ret;
+  for (auto __it = _M_cmpts.begin(), __end = std::prev(_M_cmpts.end());
+       __it != __end; ++__it)
+    {
+      __ret /= *__it;
+    }
+  return __ret;
+}
+
+bool
+path::has_root_name() const
+{
+  if (_M_type == _Type::_Root_name)
+    return true;
+  if (!_M_cmpts.empty() && _M_cmpts.begin()->_M_type == _Type::_Root_name)
+    return true;
+  return false;
+}
+
+bool
+path::has_root_directory() const
+{
+  if (_M_type == _Type::_Root_dir)
+    return true;
+  if (!_M_cmpts.empty())
+    {
+      auto __it = _M_cmpts.begin();
+      if (__it->_M_type == _Type::_Root_name)
+        ++__it;
+      if (__it != _M_cmpts.end() && __it->_M_type == _Type::_Root_dir)
+        return true;
+    }
+  return false;
+}
+
+bool
+path::has_root_path() const
+{
+  if (_M_type == _Type::_Root_name || _M_type == _Type::_Root_dir)
+    return true;
+  if (!_M_cmpts.empty())
+    {
+      auto __type = _M_cmpts.front()._M_type;
+      if (__type == _Type::_Root_name || __type == _Type::_Root_dir)
+        return true;
+    }
+  return false;
+}
+
+bool
+path::has_relative_path() const
+{
+  if (_M_type == _Type::_Filename)
+    return true;
+  if (!_M_cmpts.empty())
+    {
+      auto __it = _M_cmpts.begin();
+      if (__it->_M_type == _Type::_Root_name)
+        ++__it;
+      if (__it != _M_cmpts.end() && __it->_M_type == _Type::_Root_dir)
+        ++__it;
+      if (__it != _M_cmpts.end())
+        return true;
+    }
+  return false;
+}
+
+
+bool
+path::has_parent_path() const
+{
+  return _M_cmpts.size() > 1;
+}
+
+bool
+path::has_filename() const
+{
+  return !empty();
+}
+
+std::pair<const path::string_type*, std::size_t>
+path::_M_find_extension() const
+{
+  const std::string* s = nullptr;
+
+  if (_M_type != _Type::_Multi)
+    s = &_M_pathname;
+  else if (!_M_cmpts.empty())
+    {
+      const auto& c = _M_cmpts.back();
+      if (c._M_type == _Type::_Filename)
+	s = &c._M_pathname;
+    }
+
+  if (s)
+    {
+      if (auto sz = s->size())
+	{
+	  if (sz <= 2 && (*s)[0] == '.')
+	    {
+	      if (sz == 1 || (*s)[1] == '.')  // filename is "." or ".."
+		return { s, string_type::npos };
+	      else
+		return { s, 0 };  // filename is like ".?"
+	    }
+	  return { s, s->rfind('.') };
+	}
+    }
+  return {};
+}
+
+void
+path::_M_split_cmpts()
+{
+  _M_type = _Type::_Multi;
+  _M_cmpts.clear();
+
+  if (_M_pathname.empty())
+    return;
+
+  size_t pos = 0;
+  const size_t len = _M_pathname.size();
+
+  // look for root name or root directory
+  if (_S_is_dir_sep(_M_pathname[0]))
+    {
+      // look for root name, such as "//" or "//foo"
+      if (len > 1 && _M_pathname[1] == _M_pathname[0])
+	{
+	  if (len == 2)
+	    {
+	      // entire path is just "//"
+	      _M_type = _Type::_Root_name;
+	      return;
+	    }
+
+	  if (!_S_is_dir_sep(_M_pathname[2]))
+	    {
+	      // got root name, find its end
+	      pos = 3;
+	      while (pos < len && !_S_is_dir_sep(_M_pathname[pos]))
+		++pos;
+	      _M_add_root_name(pos);
+	      if (pos < len) // also got root directory
+		_M_add_root_dir(pos);
+	    }
+	  else
+	    {
+	      // got something like "///foo" which is just a root directory
+	      // composed of multiple redundant directory separators
+	      _M_add_root_dir(0);
+	    }
+	}
+      else // got root directory
+	_M_add_root_dir(0);
+      ++pos;
+    }
+#ifdef _GLIBCXX_FILESYSTEM_IS_WINDOWS
+  else if (len > 1 && _M_pathname[1] == L':')
+    {
+      // got disk designator
+      _M_add_root_name(2);
+      if (len > 2 && _S_is_dir_sep(_M_pathname[2]))
+	_M_add_root_dir(2);
+      pos = 2;
+    }
+#endif
+
+  size_t back = pos;
+  while (pos < len)
+    {
+      if (_S_is_dir_sep(_M_pathname[pos]))
+	{
+	  if (back != pos)
+	    _M_add_filename(back, pos - back);
+	  back = ++pos;
+	}
+      else
+	++pos;
+    }
+
+  if (back != pos)
+    _M_add_filename(back, pos - back);
+  else if (_S_is_dir_sep(_M_pathname.back()))
+    {
+      // [path.itr]/8
+      // "Dot, if one or more trailing non-root slash characters are present."
+      if (_M_cmpts.back()._M_type == _Type::_Filename)
+	{
+	  const auto& last = _M_cmpts.back();
+	  pos = last._M_pos + last._M_pathname.size();
+	  _M_cmpts.emplace_back(string_type(1, '.'), _Type::_Filename, pos);
+	}
+    }
+
+  _M_trim();
+}
+
+void
+path::_M_add_root_name(size_t n)
+{
+  _M_cmpts.emplace_back(_M_pathname.substr(0, n), _Type::_Root_name, 0);
+}
+
+void
+path::_M_add_root_dir(size_t pos)
+{
+  _M_cmpts.emplace_back(_M_pathname.substr(pos, 1), _Type::_Root_dir, pos);
+}
+
+void
+path::_M_add_filename(size_t pos, size_t n)
+{
+  _M_cmpts.emplace_back(_M_pathname.substr(pos, n), _Type::_Filename, pos);
+}
+
+void
+path::_M_trim()
+{
+  if (_M_cmpts.size() == 1)
+    {
+      _M_type = _M_cmpts.front()._M_type;
+      _M_cmpts.clear();
+    }
+}
+
+path::string_type
+path::_S_convert_loc(const char* __first, const char* __last,
+               const std::locale& __loc)
+{
+  auto& __cvt = std::use_facet<codecvt<wchar_t, char, mbstate_t>>(__loc);
+  basic_string<wchar_t> __ws;
+  if (!__str_codecvt_in(__first, __last, __ws, __cvt))
+    _GLIBCXX_THROW_OR_ABORT(filesystem_error(
+	  "Cannot convert character sequence",
+	  std::make_error_code(errc::illegal_byte_sequence)));
+#ifdef _GLIBCXX_FILESYSTEM_IS_WINDOWS
+  return __ws;
+#else
+  return _Cvt<wchar_t>::_S_convert(__ws.data(), __ws.data() + __ws.size());
+#endif
+}
+
+std::size_t
+std::experimental::filesystem::hash_value(const path& p) noexcept
+{
+  // [path.non-member]
+  // "If for two paths, p1 == p2 then hash_value(p1) == hash_value(p2)."
+  // Equality works as if by traversing the range [begin(), end()), meaning
+  // e.g. path("a//b") == path("a/b"), so we cannot simply hash _M_pathname
+  // but need to iterate over individual elements. Use the hash_combine from
+  // http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2014/n3876.pdf
+  size_t seed = 0;
+  for (const auto& x : p)
+    {
+      seed ^= std::hash<path::string_type>()(x.native()) + 0x9e3779b9
+	+ (seed<<6) + (seed>>2);
+    }
+  return seed;
+}
Index: libstdc++-v3/src/filesystem/dir.cc
===================================================================
--- libstdc++-v3/src/filesystem/dir.cc	(.../tags/gcc_5_2_0_release)	(nonexistent)
+++ libstdc++-v3/src/filesystem/dir.cc	(.../branches/gcc-5-branch)	(wersja 227896)
@@ -0,0 +1,403 @@
+// Class filesystem::directory_entry etc. -*- C++ -*-
+
+// Copyright (C) 2014-2015 Free Software Foundation, Inc.
+//
+// This file is part of the GNU ISO C++ Library.  This library is free
+// software; you can redistribute it and/or modify it under the
+// terms of the GNU General Public License as published by the
+// Free Software Foundation; either version 3, or (at your option)
+// any later version.
+
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+
+// Under Section 7 of GPL version 3, you are granted additional
+// permissions described in the GCC Runtime Library Exception, version
+// 3.1, as published by the Free Software Foundation.
+
+// You should have received a copy of the GNU General Public License and
+// a copy of the GCC Runtime Library Exception along with this program;
+// see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see
+// <http://www.gnu.org/licenses/>.
+
+#include <experimental/filesystem>
+#include <utility>
+#include <stack>
+#include <string.h>
+#include <errno.h>
+#ifdef _GLIBCXX_HAVE_DIRENT_H
+# ifdef _GLIBCXX_HAVE_SYS_TYPES_H
+#  include <sys/types.h>
+# endif
+# include <dirent.h>
+#else
+# error "the <dirent.h> header is needed to build the Filesystem TS"
+#endif
+
+#ifdef _GLIBCXX_FILESYSTEM_IS_WINDOWS
+# undef opendir
+# define opendir _wopendir
+#endif
+
+namespace fs = std::experimental::filesystem;
+
+namespace
+{
+  struct ErrorCode
+  {
+    ErrorCode(std::error_code* p) : ec(p) { }
+
+    ErrorCode(ErrorCode&& e) : ec(std::exchange(e.ec, nullptr)) { }
+
+    ~ErrorCode() { if (ec) ec->clear(); }
+
+    void assign(int err)
+    {
+      ec->assign(err, std::generic_category());
+      ec = nullptr;
+    }
+
+    explicit operator bool() { return ec != nullptr; }
+
+    std::error_code* ec;
+  };
+}
+
+struct fs::_Dir
+{
+  _Dir() : dirp(nullptr) { }
+
+  _Dir(DIR* dirp, const fs::path& path) : dirp(dirp), path(path) { }
+
+  _Dir(_Dir&& d)
+  : dirp(std::exchange(d.dirp, nullptr)), path(std::move(d.path)),
+    entry(std::move(d.entry)), type(d.type)
+  { }
+
+  _Dir& operator=(_Dir&&) = delete;
+
+  ~_Dir() { if (dirp) ::closedir(dirp); }
+
+  bool advance(ErrorCode);
+
+  DIR*			dirp;
+  fs::path		path;
+  directory_entry	entry;
+  file_type		type = file_type::none;
+};
+
+namespace
+{
+  template<typename Bitmask>
+    inline bool is_set(Bitmask obj, Bitmask bits)
+    {
+      return (obj & bits) != Bitmask::none;
+    }
+
+  fs::_Dir
+  opendir(const fs::path& p, fs::directory_options options, ErrorCode ec)
+  {
+    if (DIR* dirp = ::opendir(p.c_str()))
+      return {dirp, p};
+
+    const int err = errno;
+    if (err == EACCES
+        && is_set(options, fs::directory_options::skip_permission_denied))
+      return {};
+
+    if (!ec)
+      _GLIBCXX_THROW_OR_ABORT(fs::filesystem_error(
+            "directory iterator cannot open directory", p,
+            std::error_code(err, std::generic_category())));
+
+    ec.assign(err);
+    return {};
+  }
+
+  inline std::shared_ptr<fs::_Dir>
+  make_shared_dir(fs::_Dir&& dir)
+  {
+    if (dir.dirp)
+      return std::make_shared<fs::_Dir>(std::move(dir));
+    return {};
+  }
+
+  inline fs::file_type
+  get_file_type(const dirent& d __attribute__((__unused__)))
+  {
+#ifdef _GLIBCXX_HAVE_STRUCT_DIRENT_D_TYPE
+    switch (d.d_type)
+    {
+    case DT_BLK:
+      return fs::file_type::block;
+    case DT_CHR:
+      return fs::file_type::character;
+    case DT_DIR:
+      return fs::file_type::directory;
+    case DT_FIFO:
+      return fs::file_type::fifo;
+    case DT_LNK:
+      return fs::file_type::symlink;
+    case DT_REG:
+      return fs::file_type::regular;
+    case DT_SOCK:
+      return fs::file_type::socket;
+    case DT_UNKNOWN:
+      return fs::file_type::unknown;
+    default:
+      return fs::file_type::none;
+    }
+#else
+    return fs::file_type::none;
+#endif
+  }
+
+  int
+  native_readdir(DIR* dirp, ::dirent*& entryp)
+  {
+#ifdef _GLIBCXX_FILESYSTEM_IS_WINDOWS
+    errno = 0;
+    if ((entryp = ::readdir(dirp)))
+      return 0;
+    return errno;
+#else
+    return ::readdir_r(dirp, entryp, &entryp);
+#endif
+  }
+}
+
+bool
+fs::_Dir::advance(ErrorCode ec)
+{
+  ::dirent ent;
+  ::dirent* result = &ent;
+  if (int err = native_readdir(dirp, result))
+    {
+      if (!ec)
+	_GLIBCXX_THROW_OR_ABORT(filesystem_error(
+	      "directory iterator cannot advance",
+	      std::error_code(err, std::generic_category())));
+      ec.assign(err);
+      return true;
+    }
+  else if (result != nullptr)
+    {
+      // skip past dot and dot-dot
+      if (!strcmp(ent.d_name, ".") || !strcmp(ent.d_name, ".."))
+	return advance(std::move(ec));
+      entry = fs::directory_entry{path / ent.d_name};
+      type = get_file_type(ent);
+      return true;
+    }
+  else
+    {
+      // reached the end
+      entry = {};
+      type = fs::file_type::none;
+      return false;
+    }
+}
+
+fs::directory_iterator::
+directory_iterator(const path& p, directory_options options, error_code* ec)
+: directory_iterator(make_shared_dir(opendir(p, options, ec)), ec)
+{ }
+
+fs::directory_iterator::
+directory_iterator(std::shared_ptr<_Dir> dir, error_code* ec)
+: _M_dir(std::move(dir))
+{
+  if (_M_dir && !_M_dir->advance(ec))
+    _M_dir.reset();
+}
+
+const fs::directory_entry&
+fs::directory_iterator::operator*() const
+{
+  if (!_M_dir)
+    _GLIBCXX_THROW_OR_ABORT(filesystem_error(
+	  "non-dereferenceable directory iterator",
+	  std::make_error_code(errc::invalid_argument)));
+  return _M_dir->entry;
+}
+
+fs::directory_iterator&
+fs::directory_iterator::operator++()
+{
+  if (!_M_dir)
+    _GLIBCXX_THROW_OR_ABORT(filesystem_error(
+	  "cannot advance non-dereferenceable directory iterator",
+	  std::make_error_code(errc::invalid_argument)));
+  if (!_M_dir->advance(nullptr))
+    _M_dir.reset();
+  return *this;
+}
+
+fs::directory_iterator&
+fs::directory_iterator::increment(error_code& ec) noexcept
+{
+  if (!_M_dir)
+    {
+      ec = std::make_error_code(errc::invalid_argument);
+      return *this;
+    }
+  if (!_M_dir->advance(&ec))
+    _M_dir.reset();
+  return *this;
+}
+
+using Dir_iter_pair = std::pair<fs::_Dir, fs::directory_iterator>;
+
+struct fs::recursive_directory_iterator::_Dir_stack : std::stack<_Dir>
+{
+  void clear() { c.clear(); }
+};
+
+fs::recursive_directory_iterator::
+recursive_directory_iterator(const path& p, directory_options options,
+                                 error_code* ec)
+: _M_options(options), _M_pending(true)
+{
+  if (DIR* dirp = ::opendir(p.c_str()))
+    {
+      _M_dirs = std::make_shared<_Dir_stack>();
+      _M_dirs->push(_Dir{ dirp, p });
+      if (!_M_dirs->top().advance(ec))
+	_M_dirs.reset();
+    }
+  else
+    {
+      const int err = errno;
+      if (err == EACCES
+	  && is_set(options, fs::directory_options::skip_permission_denied))
+	return;
+
+      if (!ec)
+	_GLIBCXX_THROW_OR_ABORT(filesystem_error(
+	      "recursive directory iterator cannot open directory", p,
+	      std::error_code(err, std::generic_category())));
+
+      ec->assign(err, std::generic_category());
+    }
+}
+
+fs::recursive_directory_iterator::~recursive_directory_iterator() = default;
+
+int
+fs::recursive_directory_iterator::depth() const
+{
+  return int(_M_dirs->size()) - 1;
+}
+
+const fs::directory_entry&
+fs::recursive_directory_iterator::operator*() const
+{
+  return _M_dirs->top().entry;
+}
+
+fs::recursive_directory_iterator&
+fs::recursive_directory_iterator::
+operator=(const recursive_directory_iterator& other) noexcept = default;
+
+fs::recursive_directory_iterator&
+fs::recursive_directory_iterator::
+operator=(recursive_directory_iterator&& other) noexcept = default;
+
+fs::recursive_directory_iterator&
+fs::recursive_directory_iterator::operator++()
+{
+  error_code ec;
+  increment(ec);
+  if (ec.value())
+    _GLIBCXX_THROW_OR_ABORT(filesystem_error(
+	  "cannot increment recursive directory iterator", ec));
+  return *this;
+}
+
+namespace
+{
+  bool
+  recurse(const fs::_Dir& d, fs::directory_options options, std::error_code& ec)
+  {
+    bool follow_symlink
+      = is_set(options, fs::directory_options::follow_directory_symlink);
+#ifdef _GLIBCXX_HAVE_STRUCT_DIRENT_D_TYPE
+    if (d.type == fs::file_type::directory)
+      return true;
+    if (d.type == fs::file_type::symlink && follow_symlink)
+      return d.entry.status().type() == fs::file_type::directory;
+    if (d.type != fs::file_type::none && d.type != fs::file_type::unknown)
+      return false;
+#endif
+    const fs::path& path = d.entry.path();
+    auto type = fs::symlink_status(path, ec).type();
+    if (ec.value())
+      return false;
+    if (type == fs::file_type::symlink)
+      {
+	if (!follow_symlink)
+	  return false;
+	type = fs::status(path, ec).type();
+      }
+    return type == fs::file_type::directory;
+  }
+}
+
+fs::recursive_directory_iterator&
+fs::recursive_directory_iterator::increment(error_code& ec) noexcept
+{
+  if (!_M_dirs)
+    {
+      ec = std::make_error_code(errc::invalid_argument);
+      return *this;
+    }
+
+  auto& top = _M_dirs->top();
+
+  if (std::exchange(_M_pending, true) && recurse(top, _M_options, ec))
+    {
+      _Dir dir = opendir(top.entry.path(), _M_options, &ec);
+      if (ec.value())
+	return *this;
+      if (dir.dirp)
+	{
+	  _M_dirs->push(std::move(dir));
+	  if (!_M_dirs->top().advance(&ec)) // dir is empty
+	    pop();
+	  return *this;
+	}
+      // else skip permission denied and continue in parent dir
+    }
+
+  ec.clear();
+  while (!_M_dirs->top().advance(&ec) && !ec.value())
+    {
+      _M_dirs->pop();
+      if (_M_dirs->empty())
+	{
+	  _M_dirs.reset();
+	  return *this;
+	}
+    }
+  return *this;
+}
+
+void
+fs::recursive_directory_iterator::pop()
+{
+  if (!_M_dirs)
+    _GLIBCXX_THROW_OR_ABORT(filesystem_error(
+	  "cannot pop non-dereferenceable recursive directory iterator",
+	  std::make_error_code(errc::invalid_argument)));
+
+  do {
+    _M_dirs->pop();
+    if (_M_dirs->empty())
+      {
+	_M_dirs.reset();
+	return;
+      }
+  } while (!_M_dirs->top().advance(nullptr));
+}
